/**
  ******************************************************************************
  * @file    vk1621.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vk1621 functions. 
	*          ļ VK1621
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vk1621.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VK1621_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VK1621ο·
unsigned char vk1621_segtab[VK1621_SEGNUM]={
	0,1,2,3,4,5,6,7,8,9,						//SEG0-SEG9
	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
	20,21,22,23,24,25,26,27,28,29,	//SEG20-SEG29
	30,31														//SEG30-SEG31
};
//LCDʵֻSEG10SEG21ʹ
//.hļVK1621_SEGNUM=12
//const unsigned char vk1621_segtab[VK1621_SEGNUM]={	
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,													//SEG20-SEG21
//};
//vk1621_dispramӦоƬʾRAM
unsigned char vk1621_dispram[VK1621_SEGNUM];
//Ӧvk1621_segtab[VK1621_SEGNUM]
//ʾRAM bufferֻʹõ4λbit0->com0,bit1->com1,bit2->com2,bit3->com3
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vk1621_dispram[VK1621_SEGNUM]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg0   			vk1621_dispram[0]
	  ,     1C,    1G,      1B,     //seg1				vk1621_dispram[1]
	2D,     2E,    2F,      2A,     //seg2				vk1621_dispram[2]	
	  ,     2C,    2G,      2B,     //seg3				vk1621_dispram[3]
	3D,     3E,    3F,      3A,		  //seg4				vk1621_dispram[4]
	  ,     3C,    3G,      3B,			//seg5				vk1621_dispram[5]
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xF5,0x05,0xD3,0x97,0x27,0xB6,0xF6,0x15,0xF7,0xB7,0x02,0xE0,0xC6,0x67,0x05
};
unsigned char vk1621_addrbit=6;//icramַA5-A0,
unsigned char vk1621_segi,vk1621_comi;
unsigned char vk1621_maxcom;//com4com3com2com
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVk1621(void)
{
	VK1621_WR_L(); 
	delay_nus(VK1621_CLK);
	VK1621_WR_H();	
	delay_nus(VK1621_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVk1621(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VK1621_CS_L();   //CS Ƭѡ   
	delay_nus(VK1621_CLK/2);
	VK1621_DATA_H();  
	WriteClockVk1621();
	VK1621_DATA_L();  
	WriteClockVk1621();
	VK1621_DATA_L();  
	WriteClockVk1621();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VK1621_DATA_H(); 
	 else 
		 VK1621_DATA_L();	  

	 WriteClockVk1621();
	 Shift = Shift >> 1;
	}
  VK1621_DATA_L(); 
	WriteClockVk1621();	//һ0һλ X
  VK1621_CS_H(); 			//CS Ƭѡ  
	delay_nus(VK1621_CLK/2);
  VK1621_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVk1621(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VK1621_CS_L();  //CS Ƭѡ
	delay_nus(VK1621_CLK/2);

	VK1621_DATA_H();  
	WriteClockVk1621();  //101
	VK1621_DATA_L();  
	WriteClockVk1621();
	VK1621_DATA_H();  
	WriteClockVk1621();

	for( i = 0; i < vk1621_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1621_DATA_H(); 		
		else  
			VK1621_DATA_L();
		WriteClockVk1621();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 4; i++) 
	{

		if( Dat & Shift) 
			VK1621_DATA_H();		 
   	else  
			VK1621_DATA_L();
		WriteClockVk1621();
		Shift = Shift << 1;
	}   
  VK1621_CS_H(); //CS Ƭѡ
	delay_nus(VK1621_CLK/2);	
  VK1621_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽݵ4λЧ)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVk1621(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VK1621_CS_L();   //CS Ƭѡ 
	delay_nus(VK1621_CLK/2);

	VK1621_DATA_H();  
	WriteClockVk1621();  //101
	VK1621_DATA_L();  
	WriteClockVk1621();
	VK1621_DATA_H();  
	WriteClockVk1621();

	Shift = 0x20;
	for( i = 0; i < vk1621_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1621_DATA_H(); 		
		else  
			VK1621_DATA_L();
		WriteClockVk1621();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 4; i++) 
		{
			if( dataval & Shift) 
				VK1621_DATA_H();		 
			else  
				VK1621_DATA_L();
			WriteClockVk1621();
			Shift = Shift << 1;
		}   
	}
  VK1621_CS_H();   //CS Ƭѡ
	delay_nus(VK1621_CLK/2);	 
  VK1621_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vk1621_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0x0fȫ 0x00ȫ 0x05 0x0a 0x03 
* Input          dat->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1621_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[32];
	
	for(segi=0;segi<32;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVk1621(0,dispram,32);//4bitַԶ1
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1621_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVk1621(seg,(1<<com));
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1621_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVk1621(seg,~(1<<com));
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1621_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVk1621(OSC_OFF);
	WriteCommandVk1621(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1621_Exit_Standby(void)
{	
	//˳͹״̬vk1621
	WriteCommandVk1621(OSC_ON);
	WriteCommandVk1621(DISP_ON);
	WriteCommandVk1621(COM_1_3__4);vk1621_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1621(COM_1_3__3);vk1621_maxcom=3;	//1/3bias 3com
//	WriteCommandVk1621(COM_1_3__2);vk1621_maxcom=2;	//1/3bias 2com
//	WriteCommandVk1621(COM_1_2__4);vk1621_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1621(COM_1_2__3);vk1621_maxcom=3;	//1/2bias 3com
//	WriteCommandVk1621(COM_1_2__2);vk1621_maxcom=2;	//1/2bias 2com
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1621_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VK1621_CS_PORT, VK1621_CS_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1621_RD_PORT, VK1621_RD_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1621_WR_PORT, VK1621_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1621_DAT_PORT, VK1621_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
//	GPIO_SetMode(VK1621_DAT_PORT, VK1621_DAT_PIN, GPIO_MODE_QUASI); //ҪΪ˫IOڶʱΪIO
		
	VK1621_CS_H();      
	VK1621_RD_H();  //RDŲߵƽ                  
	VK1621_WR_H();  
	VK1621_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1621_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vk1621_Lowlevel_Init();
	//
	WriteCommandVk1621(OSC_ON);
	WriteCommandVk1621(DISP_ON);
	WriteCommandVk1621(COM_1_3__4);vk1621_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1621(COM_1_3__3);vk1621_maxcom=3;	//1/3bias 3com com2/com1/com0
//	WriteCommandVk1621(COM_1_3__2);vk1621_maxcom=2;	//1/3bias 2com com1/com0
//	WriteCommandVk1621(COM_1_2__4);vk1621_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1621(COM_1_2__3);vk1621_maxcom=3;	//1/2bias 3com com2/com1/com0
//	WriteCommandVk1621(COM_1_2__2);vk1621_maxcom=2;	//1/2bias 2com com1/com0
	//ϵĬ(δùܹرս͹)
//	WriteCommandVk1621(BUZZ_2KHZ);
//	WriteCommandVk1621(BUZZ_4KHZ);
//	WriteCommandVk1621(BUZZ_ON);
	WriteCommandVk1621(BUZZ_OFF);
	WriteCommandVk1621(IRQ_DIS);
	WriteCommandVk1621(TIMER_DIS);
	WriteCommandVk1621(WDT_DIS);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vk1621_dispram[0]=shuzi_zimo[dat8]>>4;
	vk1621_dispram[1]&=0xf8;
	vk1621_dispram[1]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat/10%10; 	//ʾʮλ
	vk1621_dispram[2]=shuzi_zimo[dat8]>>4;
	vk1621_dispram[3]&=0xf8;
	vk1621_dispram[3]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat%10;			//ʾλ
	vk1621_dispram[4]=shuzi_zimo[dat8]>>4;
	vk1621_dispram[5]&=0xf8;
	vk1621_dispram[5]|=shuzi_zimo[dat8]&0x07;
		
	if(dat<100)				//С100λʾ
	{
		vk1621_dispram[0]&=0xf0;
		vk1621_dispram[1]&=0xf8;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vk1621_dispram[2]&=0xf0;
		vk1621_dispram[3]&=0xf8;
	}
	//SEG11
//	Write1DataVk1621(0,vk1621_dispram[0]);
//	Write1DataVk1621(1,vk1621_dispram[1]);
//	Write1DataVk1621(2,vk1621_dispram[2]);
//	Write1DataVk1621(3,vk1621_dispram[3]);
//	Write1DataVk1621(4,vk1621_dispram[4]);
//	Write1DataVk1621(5,vk1621_dispram[5]);
	//SEGͶ
	WritenDataVk1621(0,&vk1621_dispram[0],6);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1621_Main(void)
{	
	Vk1621_Init();
	Vk1621_DisAll(0x00);
	while(1)
	{
		Vk1621_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1621_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vk1621_DisAll(0x00);			//LCDȫ
		for(vk1621_segi=0;vk1621_segi<VK1621_SEGNUM;vk1621_segi++)//seg
		{
			for(vk1621_comi=0;vk1621_comi<vk1621_maxcom;vk1621_comi++)//com
			{
				Vk1621_DisSegComOn(vk1621_segtab[vk1621_segi],vk1621_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vk1621_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vk1621_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vk1621_segi=0;vk1621_segi<VK1621_SEGNUM;vk1621_segi++)//seg
		{
			for(vk1621_comi=0;vk1621_comi<vk1621_maxcom;vk1621_comi++)//com
			{
				Vk1621_DisSegComOff(vk1621_segtab[vk1621_segi],vk1621_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vk1621_DisAll(0x0f);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vk1621_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1621_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vk1621_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
